MODULE nlte_paramdef_h

IMPLICIT NONE

!****************************************************************************
!
!       Merging of different parameters definitions for new NLTE 15um param
!
!       jul 2012    fgg+malv
!****************************************************************************
! *** Old mz1d.par ***
! Grids parameters :

integer,parameter :: nztabul=79 ! # points in tabulation of Tesc & VC (ISO)

! NLTE parameters:

integer,parameter :: nltot=20   ! incluye el actual # alt in NLTE module 
                                ! y el # alturas del Tstar110

integer,parameter :: nl=12     ! actual # alt in NLTE module & C.Matrix 
integer,parameter :: nl2=nl-2  ! = nl-2, needed for matrix inversion (mmh2)

integer,parameter :: nzy = (nl-1)*4 + 1  ! Fine grid for C.Matrix

integer,parameter :: nl_cts = 2 + nltot-nl ! actual # alt para Tstar110
integer,parameter :: nzy_cts = (nl_cts-1)*4 + 1 ! fine grid for transmit calculation


!  Other NLTE parameters:
integer,parameter :: nisot=4    ! number of isotopes considered
integer,parameter :: nb=41      ! number of bands included

integer,parameter :: nhist=36    ! # of temps in histogr.
                                 ! (get it from histograms!)

integer,parameter :: nbox_max = 4  ! max.# boxes in histogram


! *** Old tcr_15um.h ***

integer,parameter :: itt_cza = 13  ! Selection of NLTE scheme

real,parameter :: Ptop_atm = 3.e-10     ! Upper and lower limits of
real,parameter :: Pbottom_atm = 2.e-5   ! NLTE model

real*8,parameter :: rf19 = 1.d0, rf20 = 1.d0, rf21a = 1.d0
real*8,parameter :: rf21b = 1.d0, rf21c = 1.d0, rf33bc = 1.d0

! *** Old bloque_dlvr11.f ***

real,parameter :: nu(nisot,8) = reshape([&
                      667.3801, 1335.1317, 0., 0., 0., 0., 0., 0., &
                      662.3734,        0., 0., 0., 0., 0., 0., 0., &
                      648.4784,        0., 0., 0., 0., 0., 0., 0., &
                      664.7289,        0., 0., 0., 0., 0., 0., 0.  &
                                ],shape(nu),order=[2,1])
!        data nu(1,1),nu(1,2) /667.3801, 1335.1317/
!        data nu(2,1)/662.3734/
!        data nu(3,1)/648.4784/
!        data nu(4,1)/664.7289/

real,parameter :: nu12_0200 = 1285.4087
real,parameter :: nu12_1000 = 1388.1847

integer,parameter :: indexisot(nisot) = [26,28,36,27]

! ctes en el sistema cgs
real*8,parameter :: vlight   = 2.9979245e10
real*8,parameter :: ee       = 1.43876866
real*8,parameter :: hplanck  = 6.6260755e-27
real*8,parameter :: gamma    = 1.191043934e-5


! datos de marte
real,parameter :: imr(nisot) = [ 0.987, 0.00408, 0.0112, 0.000742 ]


END MODULE nlte_paramdef_h

